Hex Artifact Content

Artifact 644f3a91bde8ef183bde7a7ab83abe30cbc9edb8:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 69 66  2...exit 1.fi.if
00f0: 20 5b 20 2d 7a 20 22 24 7b 54 43 4c 56 45 52 53   [ -z "${TCLVERS
0100: 32 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68  2}" ]; then..ech
0110: 6f 20 27 45 52 52 4f 52 3a 20 54 68 65 20 54 43  o 'ERROR: The TC
0120: 4c 56 45 52 53 32 20 65 6e 76 69 72 6f 6e 6d 65  LVERS2 environme
0130: 6e 74 20 76 61 72 69 61 62 6c 65 20 69 73 20 6e  nt variable is n
0140: 6f 74 20 73 65 74 27 20 3e 26 32 0a 0a 09 65 78  ot set' >&2...ex
0150: 69 74 20 31 0a 66 69 0a 0a 4b 49 54 53 48 56 45  it 1.fi..KITSHVE
0160: 52 53 3d 22 30 2e 30 22 0a 42 55 49 4c 44 44 49  RS="0.0".BUILDDI
0170: 52 3d 22 24 28 70 77 64 29 2f 62 75 69 6c 64 2f  R="$(pwd)/build/
0180: 6b 69 74 73 68 2d 24 7b 4b 49 54 53 48 56 45 52  kitsh-${KITSHVER
0190: 53 7d 22 0a 4f 55 54 44 49 52 3d 22 24 28 70 77  S}".OUTDIR="$(pw
01a0: 64 29 2f 6f 75 74 22 0a 49 4e 53 54 44 49 52 3d  d)/out".INSTDIR=
01b0: 22 24 28 70 77 64 29 2f 69 6e 73 74 22 0a 4f 54  "$(pwd)/inst".OT
01c0: 48 45 52 50 4b 47 53 44 49 52 3d 22 24 28 70 77  HERPKGSDIR="$(pw
01d0: 64 29 2f 2e 2e 2f 22 0a 65 78 70 6f 72 74 20 4b  d)/../".export K
01e0: 49 54 53 48 56 45 52 53 20 42 55 49 4c 44 44 49  ITSHVERS BUILDDI
01f0: 52 20 4f 55 54 44 49 52 20 49 4e 53 54 44 49 52  R OUTDIR INSTDIR
0200: 20 4f 54 48 45 52 50 4b 47 53 44 49 52 0a 0a 23   OTHERPKGSDIR..#
0210: 20 53 65 74 20 63 6f 6e 66 69 67 75 72 65 20 6f   Set configure o
0220: 70 74 69 6f 6e 73 20 66 6f 72 20 74 68 69 73 20  ptions for this 
0230: 73 75 62 2d 70 72 6f 6a 65 63 74 0a 4c 44 46 4c  sub-project.LDFL
0240: 41 47 53 5f 41 44 44 3d 22 24 7b 4b 43 5f 4b 49  AGS_ADD="${KC_KI
0250: 54 53 48 5f 4c 44 46 4c 41 47 53 5f 41 44 44 7d  TSH_LDFLAGS_ADD}
0260: 22 0a 4c 44 46 4c 41 47 53 3d 22 24 7b 4b 43 5f  ".LDFLAGS="${KC_
0270: 4b 49 54 53 48 5f 4c 44 46 4c 41 47 53 7d 22 0a  KITSH_LDFLAGS}".
0280: 43 46 4c 41 47 53 3d 22 24 7b 4b 43 5f 4b 49 54  CFLAGS="${KC_KIT
0290: 53 48 5f 43 46 4c 41 47 53 7d 22 0a 43 50 50 46  SH_CFLAGS}".CPPF
02a0: 4c 41 47 53 3d 22 24 7b 4b 43 5f 4b 49 54 53 48  LAGS="${KC_KITSH
02b0: 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49 42 53  _CPPFLAGS}".LIBS
02c0: 3d 22 24 7b 4b 43 5f 4b 49 54 53 48 5f 4c 49 42  ="${KC_KITSH_LIB
02d0: 53 7d 22 0a 65 78 70 6f 72 74 20 4c 44 46 4c 41  S}".export LDFLA
02e0: 47 53 5f 41 44 44 20 4c 44 46 4c 41 47 53 20 43  GS_ADD LDFLAGS C
02f0: 46 4c 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c  FLAGS CPPFLAGS L
0300: 49 42 53 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  IBS..if [ -z "${
0310: 45 4e 41 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f  ENABLECOMPRESSIO
0320: 4e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 45 4e 41  N}" ]; then..ENA
0330: 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f 4e 3d 22  BLECOMPRESSION="
0340: 31 22 0a 66 69 0a 65 78 70 6f 72 74 20 45 4e 41  1".fi.export ENA
0350: 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f 4e 0a 0a  BLECOMPRESSION..
0360: 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27  rm -rf 'build' '
0370: 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69  out' 'inst'.mkdi
0380: 72 20 27 6f 75 74 27 20 27 69 6e 73 74 27 20 7c  r 'out' 'inst' |
0390: 7c 20 65 78 69 74 20 31 0a 0a 0a 28 0a 09 63 70  | exit 1...(..cp
03a0: 20 2d 72 20 27 62 75 69 6c 64 73 72 63 27 20 27   -r 'buildsrc' '
03b0: 62 75 69 6c 64 27 0a 09 63 64 20 22 24 7b 42 55  build'..cd "${BU
03c0: 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74  ILDDIR}" || exit
03d0: 20 31 0a 0a 09 23 20 46 69 78 20 75 70 20 61 72   1...# Fix up ar
03e0: 63 68 69 76 65 73 20 74 68 61 74 20 54 63 6c 20  chives that Tcl 
03f0: 67 65 74 73 20 77 72 6f 6e 67 0a 09 66 6f 72 20  gets wrong..for 
0400: 61 72 63 68 69 76 65 20 69 6e 20 2e 2e 2f 2e 2e  archive in ../..
0410: 2f 2e 2e 2f 74 63 6c 2f 69 6e 73 74 2f 6c 69 62  /../tcl/inst/lib
0420: 2f 64 64 65 2a 2f 74 63 6c 64 64 65 2a 2e 61 20  /dde*/tcldde*.a 
0430: 2e 2e 2f 2e 2e 2f 2e 2e 2f 74 63 6c 2f 69 6e 73  ../../../tcl/ins
0440: 74 2f 6c 69 62 2f 72 65 67 2a 2f 74 63 6c 72 65  t/lib/reg*/tclre
0450: 67 2a 2e 61 3b 20 64 6f 0a 09 09 69 66 20 5b 20  g*.a; do...if [ 
0460: 21 20 2d 66 20 22 24 7b 61 72 63 68 69 76 65 7d  ! -f "${archive}
0470: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e  " ]; then....con
0480: 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09 72 6d  tinue...fi....rm
0490: 20 2d 72 66 20 5f 5f 54 45 4d 50 5f 5f 0a 09 09   -rf __TEMP__...
04a0: 28 0a 09 09 09 6d 6b 64 69 72 20 5f 5f 54 45 4d  (....mkdir __TEM
04b0: 50 5f 5f 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  P__ || exit 1...
04c0: 09 63 64 20 5f 5f 54 45 4d 50 5f 5f 0a 0a 09 09  .cd __TEMP__....
04d0: 09 23 23 20 50 61 74 63 68 20 61 72 63 68 69 76  .## Patch archiv
04e0: 65 20 6e 61 6d 65 0a 09 09 09 61 72 63 68 69 76  e name....archiv
04f0: 65 3d 22 2e 2e 2f 24 7b 61 72 63 68 69 76 65 7d  e="../${archive}
0500: 22 0a 0a 09 09 09 22 24 7b 41 52 3a 2d 61 72 7d  "....."${AR:-ar}
0510: 22 20 78 20 22 24 7b 61 72 63 68 69 76 65 7d 22  " x "${archive}"
0520: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 72   || exit 1.....r
0530: 6d 20 2d 66 20 22 24 7b 61 72 63 68 69 76 65 7d  m -f "${archive}
0540: 22 0a 0a 09 09 09 22 24 7b 41 52 3a 2d 61 72 7d  "....."${AR:-ar}
0550: 22 20 63 72 20 22 24 7b 61 72 63 68 69 76 65 7d  " cr "${archive}
0560: 22 20 2a 2e 6f 20 7c 7c 20 65 78 69 74 20 31 0a  " *.o || exit 1.
0570: 09 09 09 22 24 7b 52 41 4e 4c 49 42 3a 2d 72 61  ..."${RANLIB:-ra
0580: 6e 6c 69 62 7d 22 20 22 24 7b 61 72 63 68 69 76  nlib}" "${archiv
0590: 65 7d 22 20 7c 7c 20 74 72 75 65 0a 09 09 29 0a  e}" || true...).
05a0: 09 64 6f 6e 65 0a 0a 09 23 20 43 6c 65 61 6e 75  .done...# Cleanu
05b0: 70 2c 20 6a 75 73 74 20 69 6e 63 61 73 65 20 74  p, just incase t
05c0: 68 65 20 69 6e 63 6f 6d 69 6e 67 20 64 69 72 65  he incoming dire
05d0: 63 74 6f 72 79 20 77 61 73 20 6e 6f 74 20 70 72  ctory was not pr
05e0: 65 2d 63 6c 65 61 6e 65 64 0a 09 24 7b 4d 41 4b  e-cleaned..${MAK
05f0: 45 3a 2d 6d 61 6b 65 7d 20 64 69 73 74 63 6c 65  E:-make} distcle
0600: 61 6e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  an >/dev/null 2>
0610: 2f 64 65 76 2f 6e 75 6c 6c 0a 09 72 6d 20 2d 72  /dev/null..rm -r
0620: 66 20 27 73 74 61 72 70 61 63 6b 2e 76 66 73 27  f 'starpack.vfs'
0630: 0a 0a 09 23 20 43 72 65 61 74 65 20 56 46 53 20  ...# Create VFS 
0640: 64 69 72 65 63 74 6f 72 79 0a 09 6d 6b 64 69 72  directory..mkdir
0650: 20 22 73 74 61 72 70 61 63 6b 2e 76 66 73 22 0a   "starpack.vfs".
0660: 09 6d 6b 64 69 72 20 22 73 74 61 72 70 61 63 6b  .mkdir "starpack
0670: 2e 76 66 73 2f 6c 69 62 22 0a 0a 09 23 23 20 43  .vfs/lib"...## C
0680: 6f 70 79 20 69 6e 20 61 6c 6c 20 62 75 69 6c 74  opy in all built
0690: 20 64 69 72 65 63 74 6f 72 69 65 73 0a 09 63 70   directories..cp
06a0: 20 2d 72 20 22 24 7b 4f 54 48 45 52 50 4b 47 53   -r "${OTHERPKGS
06b0: 44 49 52 7d 22 2f 2a 2f 6f 75 74 2f 2a 20 27 73  DIR}"/*/out/* 's
06c0: 74 61 72 70 61 63 6b 2e 76 66 73 2f 27 0a 0a 09  tarpack.vfs/'...
06d0: 23 23 20 52 65 6e 61 6d 65 20 74 68 65 20 22 76  ## Rename the "v
06e0: 66 73 22 20 70 61 63 6b 61 67 65 20 64 69 72 65  fs" package dire
06f0: 63 74 6f 72 79 20 74 6f 20 77 68 61 74 20 22 62  ctory to what "b
0700: 6f 6f 74 2e 74 63 6c 22 20 65 78 70 65 63 74 73  oot.tcl" expects
0710: 0a 09 6d 76 20 27 73 74 61 72 70 61 63 6b 2e 76  ..mv 'starpack.v
0720: 66 73 2f 6c 69 62 27 2f 76 66 73 2a 20 27 73 74  fs/lib'/vfs* 'st
0730: 61 72 70 61 63 6b 2e 76 66 73 2f 6c 69 62 2f 76  arpack.vfs/lib/v
0740: 66 73 27 0a 0a 09 23 23 20 49 6e 73 74 61 6c 6c  fs'...## Install
0750: 20 22 62 6f 6f 74 2e 74 63 6c 22 0a 09 63 70 20   "boot.tcl"..cp 
0760: 27 62 6f 6f 74 2e 74 63 6c 27 20 27 73 74 61 72  'boot.tcl' 'star
0770: 70 61 63 6b 2e 76 66 73 2f 27 0a 0a 09 23 23 20  pack.vfs/'...## 
0780: 49 6e 73 74 61 6c 6c 20 22 74 63 6c 6b 69 74 2e  Install "tclkit.
0790: 69 63 6f 22 0a 09 63 70 20 27 74 63 6c 6b 69 74  ico"..cp 'tclkit
07a0: 2e 69 63 6f 27 20 27 73 74 61 72 70 61 63 6b 2e  .ico' 'starpack.
07b0: 76 66 73 2f 27 0a 0a 09 23 20 46 69 67 75 72 65  vfs/'...# Figure
07c0: 20 6f 75 74 20 69 66 20 7a 6c 69 62 20 63 6f 6d   out if zlib com
07d0: 70 69 6c 65 64 20 28 69 66 20 6e 6f 74 2c 20 74  piled (if not, t
07e0: 68 65 20 73 79 73 74 65 6d 20 7a 6c 69 62 20 77  he system zlib w
07f0: 69 6c 6c 20 62 65 20 75 73 65 64 20 61 6e 64 20  ill be used and 
0800: 77 65 0a 09 23 20 77 69 6c 6c 20 6e 65 65 64 20  we..# will need 
0810: 74 6f 20 68 61 76 65 20 74 68 61 74 20 70 72 65  to have that pre
0820: 73 65 6e 74 29 0a 09 5a 4c 49 42 44 49 52 3d 22  sent)..ZLIBDIR="
0830: 24 28 63 64 20 22 24 7b 4f 54 48 45 52 50 4b 47  $(cd "${OTHERPKG
0840: 53 44 49 52 7d 2f 7a 6c 69 62 2f 69 6e 73 74 22  SDIR}/zlib/inst"
0850: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 26 26 20   2>/dev/null && 
0860: 70 77 64 29 22 0a 09 65 78 70 6f 72 74 20 5a 4c  pwd)"..export ZL
0870: 49 42 44 49 52 0a 09 69 66 20 5b 20 2d 7a 20 22  IBDIR..if [ -z "
0880: 24 7b 5a 4c 49 42 44 49 52 7d 22 20 2d 6f 20 21  ${ZLIBDIR}" -o !
0890: 20 2d 66 20 22 24 7b 5a 4c 49 42 44 49 52 7d 2f   -f "${ZLIBDIR}/
08a0: 6c 69 62 2f 6c 69 62 7a 2e 61 22 20 5d 3b 20 74  lib/libz.a" ]; t
08b0: 68 65 6e 0a 09 09 75 6e 73 65 74 20 5a 4c 49 42  hen...unset ZLIB
08c0: 44 49 52 0a 09 66 69 0a 0a 09 23 20 43 6f 70 79  DIR..fi...# Copy
08d0: 20 75 73 65 72 20 73 70 65 63 69 66 69 65 64 20   user specified 
08e0: 6b 69 74 2e 72 63 20 61 6e 64 20 74 63 6c 6b 69  kit.rc and tclki
08f0: 74 2e 69 63 6f 20 69 6e 20 74 6f 20 62 75 69 6c  t.ico in to buil
0900: 64 20 64 69 72 65 63 74 6f 72 79 2c 20 69 66 20  d directory, if 
0910: 66 6f 75 6e 64 0a 09 63 70 20 22 24 7b 4b 49 54  found..cp "${KIT
0920: 43 52 45 41 54 4f 52 5f 49 43 4f 4e 7d 22 20 22  CREATOR_ICON}" "
0930: 24 7b 42 55 49 4c 44 44 49 52 7d 2f 74 63 6c 6b  ${BUILDDIR}/tclk
0940: 69 74 2e 69 63 6f 22 0a 09 63 70 20 22 24 7b 4b  it.ico"..cp "${K
0950: 49 54 43 52 45 41 54 4f 52 5f 52 43 7d 22 20 22  ITCREATOR_RC}" "
0960: 24 7b 42 55 49 4c 44 44 49 52 7d 2f 6b 69 74 2e  ${BUILDDIR}/kit.
0970: 72 63 22 0a 0a 09 23 20 49 6e 63 6c 75 64 65 20  rc"...# Include 
0980: 65 78 74 72 61 20 6f 62 6a 65 63 74 73 20 61 73  extra objects as
0990: 20 72 65 71 75 69 72 65 64 0a 09 23 23 20 49 6e   required..## In
09a0: 69 74 69 61 6c 69 7a 65 20 6c 69 73 74 20 6f 66  itialize list of
09b0: 20 65 78 74 72 61 20 6f 62 6a 65 63 74 73 0a 09   extra objects..
09c0: 45 58 54 52 41 5f 4f 42 4a 53 3d 22 22 0a 09 65  EXTRA_OBJS=""..e
09d0: 78 70 6f 72 74 20 45 58 54 52 41 5f 4f 42 4a 53  xport EXTRA_OBJS
09e0: 0a 0a 09 23 23 20 54 6b 20 52 65 73 6f 75 72 63  ...## Tk Resourc
09f0: 65 73 20 28 6e 65 65 64 65 64 20 66 6f 72 20 57  es (needed for W
0a00: 69 6e 33 32 20 73 75 70 70 6f 72 74 29 20 2d 2d  in32 support) --
0a10: 20 72 65 6d 6f 76 65 20 6b 69 74 2d 66 6f 75 6e   remove kit-foun
0a20: 64 20 72 65 73 6f 75 72 63 65 73 20 74 6f 20 70  d resources to p
0a30: 72 65 76 65 6e 74 20 74 68 65 20 73 79 6d 62 6f  revent the symbo
0a40: 6c 73 20 66 72 6f 6d 20 62 65 69 6e 67 20 69 6e  ls from being in
0a50: 20 63 6f 6e 66 6c 69 63 74 0a 09 54 4b 44 49 52   conflict..TKDIR
0a60: 3d 22 24 28 63 64 20 22 24 7b 4f 54 48 45 52 50  ="$(cd "${OTHERP
0a70: 4b 47 53 44 49 52 7d 2f 74 6b 2f 69 6e 73 74 22  KGSDIR}/tk/inst"
0a80: 20 26 26 20 70 77 64 29 22 0a 09 54 4b 52 53 52   && pwd)"..TKRSR
0a90: 43 3d 22 24 7b 54 4b 44 49 52 7d 2f 6c 69 62 2f  C="${TKDIR}/lib/
0aa0: 74 6b 62 61 73 65 2e 72 65 73 2e 6f 22 0a 09 69  tkbase.res.o"..i
0ab0: 66 20 5b 20 2d 6e 20 22 24 7b 54 4b 44 49 52 7d  f [ -n "${TKDIR}
0ac0: 22 20 2d 61 20 2d 66 20 22 24 7b 54 4b 52 53 52  " -a -f "${TKRSR
0ad0: 43 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 45 58  C}" ]; then...EX
0ae0: 54 52 41 5f 4f 42 4a 53 3d 22 24 7b 45 58 54 52  TRA_OBJS="${EXTR
0af0: 41 5f 4f 42 4a 53 7d 20 24 7b 54 4b 52 53 52 43  A_OBJS} ${TKRSRC
0b00: 7d 22 0a 0a 09 09 65 63 68 6f 20 27 20 2a 2a 2a  }"....echo ' ***
0b10: 20 52 65 6d 6f 76 69 6e 67 20 22 6b 69 74 2e 72   Removing "kit.r
0b20: 63 22 20 73 69 6e 63 65 20 77 65 20 68 61 76 65  c" since we have
0b30: 20 54 6b 20 77 69 74 68 20 69 74 73 20 6f 77 6e   Tk with its own
0b40: 20 72 65 73 6f 75 72 63 65 20 66 69 6c 65 27 0a   resource file'.
0b50: 0a 09 09 72 6d 20 2d 66 20 22 24 7b 42 55 49 4c  ...rm -f "${BUIL
0b60: 44 44 49 52 7d 2f 6b 69 74 2e 72 63 22 0a 09 66  DDIR}/kit.rc"..f
0b70: 69 0a 0a 09 23 20 44 65 74 65 72 6d 69 6e 65 20  i...# Determine 
0b80: 69 66 20 74 61 72 67 65 74 20 69 73 20 4b 69 74  if target is Kit
0b90: 44 4c 4c 20 6f 72 20 4b 69 74 53 48 0a 09 69 66  DLL or KitSH..if
0ba0: 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d   [ "${KITTARGET}
0bb0: 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20  " = "kitdll" ]; 
0bc0: 74 68 65 6e 0a 09 09 43 4f 4e 46 49 47 55 52 45  then...CONFIGURE
0bd0: 45 58 54 52 41 3d 22 24 7b 43 4f 4e 46 49 47 55  EXTRA="${CONFIGU
0be0: 52 45 45 58 54 52 41 7d 20 2d 2d 65 6e 61 62 6c  REEXTRA} --enabl
0bf0: 65 2d 6b 69 74 64 6c 6c 22 0a 09 66 69 0a 0a 09  e-kitdll"..fi...
0c00: 23 20 43 6f 6d 70 69 6c 65 20 4b 69 74 0a 09 69  # Compile Kit..i
0c10: 66 20 5b 20 2d 7a 20 22 24 7b 5a 4c 49 42 44 49  f [ -z "${ZLIBDI
0c20: 52 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  R}" ]; then...ec
0c30: 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f 63  ho "Running: ./c
0c40: 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d  onfigure --with-
0c50: 74 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49  tcl=\"${TCLCONFI
0c60: 47 44 49 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47  GDIR}\" ${CONFIG
0c70: 55 52 45 45 58 54 52 41 7d 22 0a 0a 09 09 2e 2f  UREEXTRA}"...../
0c80: 63 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68  configure --with
0c90: 2d 74 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49  -tcl="${TCLCONFI
0ca0: 47 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49 47 55  GDIR}" ${CONFIGU
0cb0: 52 45 45 58 54 52 41 7d 0a 09 65 6c 73 65 0a 09  REEXTRA}..else..
0cc0: 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20  .echo "Running: 
0cd0: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69  ./configure --wi
0ce0: 74 68 2d 74 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f  th-tcl=\"${TCLCO
0cf0: 4e 46 49 47 44 49 52 7d 5c 22 20 2d 2d 77 69 74  NFIGDIR}\" --wit
0d00: 68 2d 7a 6c 69 62 3d 5c 22 24 7b 5a 4c 49 42 44  h-zlib=\"${ZLIBD
0d10: 49 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52  IR}\" ${CONFIGUR
0d20: 45 45 58 54 52 41 7d 22 0a 0a 09 09 2e 2f 63 6f  EEXTRA}"...../co
0d30: 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d 74  nfigure --with-t
0d40: 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  cl="${TCLCONFIGD
0d50: 49 52 7d 22 20 2d 2d 77 69 74 68 2d 7a 6c 69 62  IR}" --with-zlib
0d60: 3d 22 24 7b 5a 4c 49 42 44 49 52 7d 22 20 24 7b  ="${ZLIBDIR}" ${
0d70: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 0a  CONFIGUREEXTRA}.
0d80: 09 66 69 0a 0a 09 65 63 68 6f 20 22 52 75 6e 6e  .fi...echo "Runn
0d90: 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  ing: ${MAKE:-mak
0da0: 65 7d 20 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d  e} TCLSH_NATIVE=
0db0: 5c 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45  \"${TCLSH_NATIVE
0dc0: 7d 5c 22 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61  }\""..${MAKE:-ma
0dd0: 6b 65 7d 20 54 43 4c 53 48 5f 4e 41 54 49 56 45  ke} TCLSH_NATIVE
0de0: 3d 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45  ="${TCLSH_NATIVE
0df0: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23  }" || exit 1...#
0e00: 20 53 74 72 69 70 20 74 68 65 20 6b 69 74 20 6f   Strip the kit o
0e10: 66 20 61 6c 6c 20 73 79 6d 62 6f 6c 73 2c 20 69  f all symbols, i
0e20: 66 20 70 6f 73 73 69 62 6c 65 0a 09 69 66 20 21  f possible..if !
0e30: 20 65 63 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47   echo " ${CONFIG
0e40: 55 52 45 45 58 54 52 41 7d 20 22 20 7c 20 67 72  UREEXTRA} " | gr
0e50: 65 70 20 27 20 2d 2d 65 6e 61 62 6c 65 2d 73 79  ep ' --enable-sy
0e60: 6d 62 6f 6c 73 20 27 20 3e 2f 64 65 76 2f 6e 75  mbols ' >/dev/nu
0e70: 6c 6c 3b 20 74 68 65 6e 0a 09 09 22 24 7b 53 54  ll; then..."${ST
0e80: 52 49 50 3a 2d 73 74 72 69 70 7d 22 20 6b 69 74  RIP:-strip}" kit
0e90: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0ea0: 65 76 2f 6e 75 6c 6c 0a 09 09 22 24 7b 53 54 52  ev/null..."${STR
0eb0: 49 50 3a 2d 73 74 72 69 70 7d 22 20 2d 67 20 6c  IP:-strip}" -g l
0ec0: 69 62 74 63 6c 6b 69 74 2a 20 3e 2f 64 65 76 2f  ibtclkit* >/dev/
0ed0: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
0ee0: 0a 09 66 69 0a 0a 09 23 20 46 69 78 20 75 70 20  ..fi...# Fix up 
0ef0: 57 69 6e 33 32 20 44 4c 4c 20 6e 61 6d 65 73 0a  Win32 DLL names.
0f00: 09 23 23 20 2e 44 4c 4c 2e 41 20 2d 3e 20 2e 4c  .## .DLL.A -> .L
0f10: 49 42 0a 09 66 6f 72 20 66 69 6c 65 20 69 6e 20  IB..for file in 
0f20: 6c 69 62 74 63 6c 6b 69 74 2a 2e 64 6c 6c 2e 61  libtclkit*.dll.a
0f30: 3b 20 64 6f 0a 09 09 69 66 20 5b 20 21 20 2d 66  ; do...if [ ! -f
0f40: 20 22 24 7b 66 69 6c 65 7d 22 20 5d 3b 20 74 68   "${file}" ]; th
0f50: 65 6e 0a 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09  en....continue..
0f60: 09 66 69 0a 0a 09 09 6e 65 77 66 69 6c 65 3d 22  .fi....newfile="
0f70: 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 66 69  $(basename "${fi
0f80: 6c 65 7d 22 20 2e 64 6c 6c 2e 61 29 2e 6c 69 62  le}" .dll.a).lib
0f90: 22 0a 09 09 6d 76 20 22 24 7b 66 69 6c 65 7d 22  "...mv "${file}"
0fa0: 20 22 24 7b 6e 65 77 66 69 6c 65 7d 22 0a 09 64   "${newfile}"..d
0fb0: 6f 6e 65 0a 0a 09 23 23 20 2e 44 4c 4c 2e 44 45  one...## .DLL.DE
0fc0: 46 20 2d 3e 20 2e 44 45 46 0a 09 66 6f 72 20 66  F -> .DEF..for f
0fd0: 69 6c 65 20 69 6e 20 6c 69 62 74 63 6c 6b 69 74  ile in libtclkit
0fe0: 2a 2e 64 6c 6c 2e 64 65 66 3b 20 64 6f 0a 09 09  *.dll.def; do...
0ff0: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 66 69 6c  if [ ! -f "${fil
1000: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 63  e}" ]; then....c
1010: 6f 6e 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09  ontinue...fi....
1020: 6e 65 77 66 69 6c 65 3d 22 24 28 62 61 73 65 6e  newfile="$(basen
1030: 61 6d 65 20 22 24 7b 66 69 6c 65 7d 22 20 2e 64  ame "${file}" .d
1040: 6c 6c 2e 64 65 66 29 2e 64 65 66 22 0a 09 09 6d  ll.def).def"...m
1050: 76 20 22 24 7b 66 69 6c 65 7d 22 20 22 24 7b 6e  v "${file}" "${n
1060: 65 77 66 69 6c 65 7d 22 0a 09 64 6f 6e 65 0a 0a  ewfile}"..done..
1070: 09 23 20 44 65 74 65 72 6d 69 6e 65 20 6e 61 6d  .# Determine nam
1080: 65 20 6f 66 20 63 72 65 61 74 65 64 20 6b 69 74  e of created kit
1090: 0a 09 4b 49 54 54 41 52 47 45 54 5f 4e 41 4d 45  ..KITTARGET_NAME
10a0: 3d 27 5f 5f 65 72 72 6f 72 5f 5f 27 0a 09 69 66  ='__error__'..if
10b0: 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d   [ "${KITTARGET}
10c0: 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20  " = "kitdll" ]; 
10d0: 74 68 65 6e 0a 09 09 23 23 20 46 69 6e 64 20 74  then...## Find t
10e0: 68 65 20 6c 69 62 72 61 72 79 20 63 72 65 61 74  he library creat
10f0: 65 64 0a 09 09 66 6f 72 20 63 68 6b 6b 69 74 74  ed...for chkkitt
1100: 61 72 67 65 74 20 69 6e 20 6c 69 62 74 63 6c 6b  arget in libtclk
1110: 69 74 2a 2e 2a 3b 20 64 6f 0a 09 09 09 69 66 20  it*.*; do....if 
1120: 5b 20 21 20 2d 66 20 22 24 7b 63 68 6b 6b 69 74  [ ! -f "${chkkit
1130: 74 61 72 67 65 74 7d 22 20 5d 3b 20 74 68 65 6e  target}" ]; then
1140: 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09  .....continue...
1150: 09 66 69 0a 0a 09 09 09 69 66 20 65 63 68 6f 20  .fi.....if echo 
1160: 22 24 7b 63 68 6b 6b 69 74 74 61 72 67 65 74 7d  "${chkkittarget}
1170: 22 20 7c 20 65 67 72 65 70 20 27 5c 2e 28 6c 69  " | egrep '\.(li
1180: 62 7c 64 65 66 7c 61 29 24 27 3b 20 74 68 65 6e  b|def|a)$'; then
1190: 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09  .....continue...
11a0: 09 66 69 0a 0a 09 09 09 4b 49 54 54 41 52 47 45  .fi.....KITTARGE
11b0: 54 5f 4e 41 4d 45 3d 22 24 7b 63 68 6b 6b 69 74  T_NAME="${chkkit
11c0: 74 61 72 67 65 74 7d 22 0a 0a 09 09 09 62 72 65  target}".....bre
11d0: 61 6b 0a 09 09 64 6f 6e 65 0a 0a 09 09 23 23 20  ak...done....## 
11e0: 41 6c 73 6f 20 63 72 65 61 74 65 20 61 6e 20 65  Also create an e
11f0: 78 65 63 75 74 61 62 6c 65 20 6e 61 6d 65 64 20  xecutable named 
1200: 22 6b 69 74 22 20 73 6f 20 74 68 61 74 20 77 65  "kit" so that we
1210: 20 63 61 6e 20 72 75 6e 20 69 74 20 6c 61 74 65   can run it late
1220: 72 0a 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  r...${MAKE:-make
1230: 7d 20 74 63 6c 73 68 0a 09 09 6d 76 20 74 63 6c  } tclsh...mv tcl
1240: 73 68 20 6b 69 74 0a 09 65 6c 73 65 0a 09 09 23  sh kit..else...#
1250: 23 20 54 68 65 20 65 78 65 63 75 74 61 62 6c 65  # The executable
1260: 20 69 73 20 61 6c 77 61 79 73 20 6e 61 6d 65 64   is always named
1270: 20 22 6b 69 74 22 0a 09 09 4b 49 54 54 41 52 47   "kit"...KITTARG
1280: 45 54 5f 4e 41 4d 45 3d 27 6b 69 74 27 0a 09 66  ET_NAME='kit'..f
1290: 69 0a 09 65 78 70 6f 72 74 20 4b 49 54 54 41 52  i..export KITTAR
12a0: 47 45 54 5f 4e 41 4d 45 0a 0a 09 69 66 20 5b 20  GET_NAME...if [ 
12b0: 22 78 24 7b 4b 49 54 54 41 52 47 45 54 5f 4e 41  "x${KITTARGET_NA
12c0: 4d 45 7d 22 20 3d 20 27 78 5f 5f 65 72 72 6f 72  ME}" = 'x__error
12d0: 5f 5f 27 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  __' ]; then...ec
12e0: 68 6f 20 22 46 61 69 6c 65 64 20 74 6f 20 6c 6f  ho "Failed to lo
12f0: 63 61 74 65 20 6b 69 74 20 74 61 72 67 65 74 21  cate kit target!
1300: 22 20 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a  " >&2....exit 1.
1310: 09 66 69 0a 0a 09 23 20 49 6e 74 61 6c 6c 20 56  .fi...# Intall V
1320: 46 53 20 6f 6e 74 6f 20 6b 69 74 0a 09 23 23 20  FS onto kit..## 
1330: 44 65 74 65 72 6d 69 6e 65 20 69 66 20 77 65 20  Determine if we 
1340: 68 61 76 65 20 61 20 54 63 6c 6b 69 74 20 74 6f  have a Tclkit to
1350: 20 64 6f 20 74 68 69 73 20 77 6f 72 6b 0a 09 54   do this work..T
1360: 43 4c 4b 49 54 3d 22 24 7b 54 43 4c 4b 49 54 3a  CLKIT="${TCLKIT:
1370: 2d 74 63 6c 6b 69 74 7d 22 0a 09 69 66 20 65 63  -tclkit}"..if ec
1380: 68 6f 20 27 65 78 69 74 20 30 27 20 7c 20 22 24  ho 'exit 0' | "$
1390: 7b 54 43 4c 4b 49 54 7d 22 20 3e 2f 64 65 76 2f  {TCLKIT}" >/dev/
13a0: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
13b0: 3b 20 74 68 65 6e 0a 09 09 23 23 20 49 6e 73 74  ; then...## Inst
13c0: 61 6c 6c 20 75 73 69 6e 67 20 65 78 69 73 74 69  all using existi
13d0: 6e 67 20 54 63 6c 6b 69 74 0a 09 09 23 23 23 20  ng Tclkit...### 
13e0: 43 61 6c 6c 20 69 6e 73 74 61 6c 6c 65 72 0a 09  Call installer..
13f0: 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20  .echo "Running: 
1400: 5c 22 24 7b 54 43 4c 4b 49 54 7d 5c 22 20 69 6e  \"${TCLKIT}\" in
1410: 73 74 61 6c 6c 76 66 73 2e 74 63 6c 20 5c 22 24  stallvfs.tcl \"$
1420: 7b 4b 49 54 54 41 52 47 45 54 5f 4e 41 4d 45 7d  {KITTARGET_NAME}
1430: 5c 22 20 73 74 61 72 70 61 63 6b 2e 76 66 73 20  \" starpack.vfs 
1440: 5c 22 24 7b 45 4e 41 42 4c 45 43 4f 4d 50 52 45  \"${ENABLECOMPRE
1450: 53 53 49 4f 4e 7d 5c 22 22 0a 09 09 22 24 7b 54  SSION}\""..."${T
1460: 43 4c 4b 49 54 7d 22 20 69 6e 73 74 61 6c 6c 76  CLKIT}" installv
1470: 66 73 2e 74 63 6c 20 22 24 7b 4b 49 54 54 41 52  fs.tcl "${KITTAR
1480: 47 45 54 5f 4e 41 4d 45 7d 22 20 73 74 61 72 70  GET_NAME}" starp
1490: 61 63 6b 2e 76 66 73 20 22 24 7b 45 4e 41 42 4c  ack.vfs "${ENABL
14a0: 45 43 4f 4d 50 52 45 53 53 49 4f 4e 7d 22 20 7c  ECOMPRESSION}" |
14b0: 7c 20 65 78 69 74 20 31 0a 09 65 6c 73 65 0a 09  | exit 1..else..
14c0: 09 23 23 20 42 6f 6f 74 73 74 72 61 70 20 28 63  .## Bootstrap (c
14d0: 61 6e 6e 6f 74 20 63 72 6f 73 73 2d 63 6f 6d 70  annot cross-comp
14e0: 69 6c 65 29 0a 09 09 23 23 23 20 43 61 6c 6c 20  ile)...### Call 
14f0: 69 6e 73 74 61 6c 6c 65 72 0a 09 09 63 70 20 6b  installer...cp k
1500: 69 74 20 72 75 6e 6b 69 74 0a 09 09 65 63 68 6f  it runkit...echo
1510: 20 22 73 65 74 20 61 72 67 76 20 5b 6c 69 73 74   "set argv [list
1520: 20 7b 24 7b 4b 49 54 54 41 52 47 45 54 5f 4e 41   {${KITTARGET_NA
1530: 4d 45 7d 7d 20 73 74 61 72 70 61 63 6b 2e 76 66  ME}} starpack.vf
1540: 73 20 7b 24 7b 45 4e 41 42 4c 45 43 4f 4d 50 52  s {${ENABLECOMPR
1550: 45 53 53 49 4f 4e 7d 7d 5d 22 20 3e 20 73 65 74  ESSION}}]" > set
1560: 75 70 2e 74 63 6c 0a 09 09 65 63 68 6f 20 27 69  up.tcl...echo 'i
1570: 66 20 7b 5b 63 61 74 63 68 20 7b 20 63 6c 6f 63  f {[catch { cloc
1580: 6b 20 73 65 63 6f 6e 64 73 20 7d 5d 7d 20 7b 20  k seconds }]} { 
1590: 70 72 6f 63 20 63 6c 6f 63 6b 20 61 72 67 73 20  proc clock args 
15a0: 7b 20 72 65 74 75 72 6e 20 30 20 7d 20 7d 27 20  { return 0 } }' 
15b0: 3e 3e 20 73 65 74 75 70 2e 74 63 6c 0a 09 09 65  >> setup.tcl...e
15c0: 63 68 6f 20 27 73 6f 75 72 63 65 20 69 6e 73 74  cho 'source inst
15d0: 61 6c 6c 76 66 73 2e 74 63 6c 27 20 3e 3e 20 73  allvfs.tcl' >> s
15e0: 65 74 75 70 2e 74 63 6c 0a 0a 09 09 54 43 4c 5f  etup.tcl....TCL_
15f0: 4c 49 42 52 41 52 59 3d 22 24 28 70 77 64 29 2f  LIBRARY="$(pwd)/
1600: 73 74 61 72 70 61 63 6b 2e 76 66 73 2f 6c 69 62  starpack.vfs/lib
1610: 2f 74 63 6c 24 7b 54 43 4c 56 45 52 53 32 7d 22  /tcl${TCLVERS2}"
1620: 0a 09 09 65 78 70 6f 72 74 20 54 43 4c 5f 4c 49  ...export TCL_LI
1630: 42 52 41 52 59 0a 0a 09 09 65 63 68 6f 20 27 52  BRARY....echo 'R
1640: 75 6e 6e 69 6e 67 3a 20 65 63 68 6f 20 7c 20 2e  unning: echo | .
1650: 2f 72 75 6e 6b 69 74 20 73 65 74 75 70 2e 74 63  /runkit setup.tc
1660: 6c 27 0a 09 09 65 63 68 6f 20 7c 20 2e 2f 72 75  l'...echo | ./ru
1670: 6e 6b 69 74 20 73 65 74 75 70 2e 74 63 6c 20 7c  nkit setup.tcl |
1680: 7c 20 65 78 69 74 20 31 0a 09 66 69 0a 0a 09 23  | exit 1..fi...#
1690: 20 43 6c 65 61 6e 75 70 0a 09 69 66 20 5b 20 22   Cleanup..if [ "
16a0: 24 7b 4b 49 54 54 41 52 47 45 54 7d 22 20 3d 20  ${KITTARGET}" = 
16b0: 22 6b 69 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e  "kitdll" ]; then
16c0: 0a 09 09 23 23 20 52 65 6d 6f 76 65 20 62 75 69  ...## Remove bui
16d0: 6c 74 20 69 6e 74 65 72 70 72 65 74 65 72 73 20  lt interpreters 
16e0: 69 66 20 77 65 20 61 72 65 20 62 75 69 6c 64 69  if we are buildi
16f0: 6e 67 20 4b 69 74 44 4c 4c 20 2d 2d 0a 09 09 23  ng KitDLL --...#
1700: 23 20 74 68 65 79 27 72 65 20 6a 75 73 74 20 74  # they're just t
1710: 69 6e 79 20 73 74 75 62 73 20 61 6e 79 77 61 79  iny stubs anyway
1720: 0a 09 09 72 6d 20 2d 66 20 6b 69 74 20 72 75 6e  ...rm -f kit run
1730: 6b 69 74 0a 09 66 69 0a 0a 09 65 78 69 74 20 30  kit..fi...exit 0
1740: 0a 29 20 7c 7c 20 65 78 69 74 20 31 0a 0a 65 78  .) || exit 1..ex
1750: 69 74 20 30 0a                                   it 0.